"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isDisposable(fs) {
    return !!fs && typeof fs.dispose === 'function';
}
exports.isDisposable = isDisposable;
exports.fileSystemEventNames = ['unexpectedError', 'fileCreated', 'fileChanged', 'fileDeleted', 'directoryCreated', 'directoryDeleted'];
exports.fileSystemAsyncMethods = ['saveFile', 'deleteFile', 'deleteDirectory', 'loadTextFile', 'loadDirectoryTree', 'ensureDirectory', 'loadDirectoryChildren', 'stat'];
function isFileSystemReadSync(fs) {
    return typeof fs.loadTextFileSync === "function" &&
        typeof fs.loadDirectoryTreeSync === "function" &&
        typeof fs.loadDirectoryContentSync === "function" &&
        typeof fs.loadDirectoryChildrenSync === "function" &&
        typeof fs.statSync === "function";
}
exports.isFileSystemReadSync = isFileSystemReadSync;
//# sourceMappingURL=api.js.map