import { EventEmitter, Events } from "./api";
export interface EventHandler<S extends keyof Events> {
    types: S[];
    filter: (e: Events[S]) => boolean;
    apply: (e: Events[S]) => Events[S] | void;
}
export declare namespace EventsManager {
    interface Options {
        delay?: number;
    }
}
export declare class EventsManager {
    private options;
    readonly events: EventEmitter;
    private eventHandlers;
    constructor(options?: EventsManager.Options);
    emit(e: Events[keyof Events]): void;
    addEventHandler<S extends keyof Events>(handler: EventHandler<S>, timeout?: number): void;
    removeEventHandler<S extends keyof Events>(handler: EventHandler<S>): void;
    private _emit(e);
}
