import { Directory, DirectoryContent, File, ShallowDirectory, SimpleStats } from './model';
export declare class LocalFileSystemCrudOnly {
    baseUrl: string;
    constructor(baseUrl: string);
    saveFile(relPath: string, newContent: string): Promise<void>;
    deleteFile(relPath: string): Promise<void>;
    deleteDirectory(relPath: string, recursive?: boolean): Promise<void>;
    loadTextFile(relPath: string): Promise<string>;
    loadTextFileSync(relPath: string): string;
    loadDirectoryChildren(fullPath: string): Promise<(File | ShallowDirectory)[]>;
    loadDirectoryChildrenSync(fullPath: string): Array<File | ShallowDirectory>;
    loadDirectoryTree(fullPath?: string): Promise<Directory>;
    loadDirectoryTreeSync(fullPath?: string): Directory;
    loadDirectoryContentSync(fullPath?: string): DirectoryContent;
    stat(fullPath: string): Promise<SimpleStats>;
    statSync(fullPath: string): SimpleStats;
    ensureDirectory(relPath: string): Promise<void>;
    private getPathAndName(relPath);
}
