import { Directory, File, ShallowDirectory, SimpleStats } from './model';
import { Correlation, EventEmitter, FileSystem } from './api';
export declare class TimeoutFileSystem implements FileSystem {
    private timeout;
    private fs;
    constructor(timeout: number, fs: FileSystem);
    readonly events: EventEmitter;
    readonly baseUrl: string;
    saveFile(fullPath: string, newContent: string, correlation?: Correlation): Promise<Correlation>;
    deleteFile(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    deleteDirectory(fullPath: string, recursive?: boolean, correlation?: Correlation): Promise<Correlation>;
    loadTextFile(fullPath: string): Promise<string>;
    loadDirectoryTree(fullPath?: string): Promise<Directory>;
    loadDirectoryChildren(fullPath: string): Promise<(File | ShallowDirectory)[]>;
    stat(fullPath: string): Promise<SimpleStats>;
    ensureDirectory(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    dispose(): void;
}
