"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var utils_1 = require("./utils");
function checkExistsSync(expectedType, fs, targetPath) {
    var _a = utils_1.splitPathToDirAndFile(targetPath), name = _a.name, parentPath = _a.parentPath;
    try {
        var dirContent = fs.loadDirectoryChildrenSync(parentPath);
        return utils_1.checkExistsInDir(expectedType, dirContent, name);
    }
    catch (error) {
        return false;
    }
}
exports.checkExistsSync = checkExistsSync;
function checkExists(expectedType, fs, targetPath) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _a, name, parentPath, dirContent, error_1;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = utils_1.splitPathToDirAndFile(targetPath), name = _a.name, parentPath = _a.parentPath;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fs.loadDirectoryChildren(parentPath)];
                case 2:
                    dirContent = _b.sent();
                    return [2 /*return*/, utils_1.checkExistsInDir(expectedType, dirContent, name)];
                case 3:
                    error_1 = _b.sent();
                    return [2 /*return*/, false];
                case 4: return [2 /*return*/];
            }
        });
    });
}
exports.checkExists = checkExists;
function addContentAsync(content, fs, currentPath) {
    if (currentPath === void 0) { currentPath = ''; }
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var _this = this;
        return tslib_1.__generator(this, function (_a) {
            return [2 /*return*/, Promise.all(Object.keys(content).map(function (fileOrDirName) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
                    var fileOrDir, newPath;
                    return tslib_1.__generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                fileOrDir = content[fileOrDirName];
                                newPath = currentPath ? currentPath + '/' + fileOrDirName : fileOrDirName;
                                if (!(typeof fileOrDir === 'string')) return [3 /*break*/, 2];
                                return [4 /*yield*/, fs.saveFile(newPath, fileOrDir)];
                            case 1:
                                _a.sent();
                                return [3 /*break*/, 5];
                            case 2: return [4 /*yield*/, fs.ensureDirectory(newPath)];
                            case 3:
                                _a.sent();
                                return [4 /*yield*/, addContentAsync(fileOrDir, fs, newPath)];
                            case 4:
                                _a.sent();
                                _a.label = 5;
                            case 5: return [2 /*return*/];
                        }
                    });
                }); }))];
        });
    });
}
//# sourceMappingURL=user-utils.js.map