"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var eventemitter3_1 = require("eventemitter3");
var model_1 = require("./model");
// utility logic for filesystem implementations
function getPathNodes(path) {
    return path.split(model_1.pathSeparator).filter(function (n) { return n.length; });
}
exports.getPathNodes = getPathNodes;
function normalizePathNodes(path) {
    return path.filter(function (n) { return n.length; }).join(model_1.pathSeparator);
}
exports.normalizePathNodes = normalizePathNodes;
function splitPathToDirAndFile(targetPath) {
    var nameParentSeparator = targetPath.lastIndexOf(model_1.pathSeparator);
    return {
        parentPath: targetPath.substr(0, nameParentSeparator),
        name: targetPath.substr(nameParentSeparator + 1)
    };
}
exports.splitPathToDirAndFile = splitPathToDirAndFile;
function checkExistsInDir(expectedType, dirContent, name) {
    for (var _i = 0, dirContent_1 = dirContent; _i < dirContent_1.length; _i++) {
        var node = dirContent_1[_i];
        if (node.type === expectedType && node.name === name) {
            return true;
        }
    }
    return false;
}
exports.checkExistsInDir = checkExistsInDir;
function makeEventsEmitter() {
    return (new eventemitter3_1.EventEmitter());
}
exports.makeEventsEmitter = makeEventsEmitter;
function makeCorrelationId() {
    return (Math.random().toString(36) + '0000').substr(2, 4);
}
exports.makeCorrelationId = makeCorrelationId;
function endsWith(str, maybeSuffix) {
    return str.lastIndexOf(maybeSuffix) === str.length - maybeSuffix.length;
}
exports.endsWith = endsWith;
//# sourceMappingURL=utils.js.map