import { Correlation, FileSystem } from './api';
import { InternalEventsEmitter } from "./utils";
import { Directory, File, ShallowDirectory, SimpleStats } from "./model";
export declare const noConnectionError = "WampClientFileSystem hasn't opened connection yet (forgot to init()?).";
export declare class WampClientFileSystem implements FileSystem {
    baseUrl: string;
    private realm;
    private initTimeout;
    readonly events: InternalEventsEmitter;
    private connection;
    private session?;
    private realmPrefix?;
    constructor(baseUrl: string, realm: string, initTimeout?: number);
    init(): Promise<WampClientFileSystem>;
    saveFile(fullPath: string, newContent: string, correlation?: Correlation): Promise<Correlation>;
    deleteFile(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    deleteDirectory(fullPath: string, recursive?: boolean, correlation?: Correlation): Promise<Correlation>;
    ensureDirectory(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    loadTextFile(fullPath: string): Promise<string>;
    loadDirectoryTree(fullPath?: string): Promise<Directory>;
    loadDirectoryChildren(fullPath: string): Promise<(File | ShallowDirectory)[]>;
    stat(fullPath: string): Promise<SimpleStats>;
    dispose(): void;
}
