import { Correlation, FileSystem } from "../src/api";
import { InternalEventsEmitter } from '../src/utils';
import { Directory, File, ShallowDirectory, SimpleStats } from "../src/model";
export declare class SlowFs implements FileSystem {
    private delay;
    readonly events: InternalEventsEmitter;
    baseUrl: string;
    private fs;
    constructor(delay: number);
    saveFile(fullPath: string, newContent: string, correlation?: Correlation): Promise<Correlation>;
    deleteFile(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    deleteDirectory(fullPath: string, recursive?: boolean, correlation?: Correlation): Promise<Correlation>;
    ensureDirectory(fullPath: string, correlation?: Correlation): Promise<Correlation>;
    loadTextFile(fullPath: string): Promise<string>;
    loadDirectoryTree(fullPath?: string): Promise<Directory>;
    loadDirectoryChildren(fullPath: string): Promise<(File | ShallowDirectory)[]>;
    stat(fullPath: string): Promise<SimpleStats>;
    dispose(): void;
}
